program Demo;
{ Demo program for OvrSub }
uses
  Dos, Overlay, DemoUnit, OvrSub;

{$O DemoUnit}

procedure CallOverlay (OvrName : string);
var
  Result : Word;
begin
  Writeln ('Using overlay file ',OvrName);

  {Open overlay file, initialize overlay manager}
  OvrInit(OvrName);
  if OvrResult <> 0 then begin
    Writeln('OvrInit error: ', OvrResult);
    Halt(1);
  end;

  {Adjust static dispatchers}
  Result := OvrSubstitute(True,False,True,True);
  if Result <> 0 then begin
    Writeln('OvrSubstitute error: ', Result);
    Halt(1);
  end;

  {Call procedure in overlaid unit}
  DemoProc (OvrName);

  {Close overlay file}
  Result := OvrClose;
  if Result <> 0 then begin
    Writeln('OvrClose error: ', Result);
    Halt(1);
  end;
  Writeln (OvrName, ' closed');
  Writeln;
end;

begin
  CallOverlay ('1.OVR');
  CallOverlay ('2.OVR');
end.
